/* these two structures is were all of the errors are stored. 
   each time a function is called to check a particular blockette,
   one of these structures is created. When the blockette has been
   completely checked, they are printed. 

   The result_struct contains a linked list of error_strutcts. One
   for each error encountered in the blockette

   the result_struct.error field will be set as follows:
       0 for no errors or warnings
       1 for ONLY warnings have occured
       2 for ONLY errors have occured
       3 for BOTH errors and warnings have occured */

struct error_struct {
    int field_number;
    char field_string[256];
    char error_string[256];
    int error;
    struct error_struct *next;
};

struct result_struct {
    int blockette_number;
    char blockette_name[128];
    int start_record_number;
    int end_record_number;
    int error;
    int mem_alloc_error;
    struct error_struct *next;
};



/* the sanity checker must know what version we are working with. 
   So, define a version if not already defined */

#ifndef VERSION 
#define VERSION 2.4 
#endif 


/* lots of function declarations..... */

int blockette_sanity_checker();
int print_blockette();

int check_blockette_5();
int check_blockette_8();
int check_blockette_10();
int check_blockette_11();
int check_blockette_12();
int check_blockette_30();
int check_blockette_31();
int check_blockette_32();
int check_blockette_33();
int check_blockette_34();
int check_blockette_35();
int check_blockette_41();
int check_blockette_42();
int check_blockette_43();
int check_blockette_44();
int check_blockette_45();
int check_blockette_46();
int check_blockette_47();
int check_blockette_48();
int check_blockette_50();
int check_blockette_51();
int check_blockette_52();
int check_blockette_53();
int check_blockette_54();
int check_blockette_55();
int check_blockette_56();
int check_blockette_57();
int check_blockette_58();
int check_blockette_59();
int check_blockette_60();
int check_blockette_61();
int check_blockette_62();
int check_blockette_70();
int check_blockette_71();
int check_blockette_72();
int check_blockette_73();
int check_blockette_74();



int print_blockette_5();
int print_blockette_8();
int print_blockette_10();
int print_blockette_11();
int print_blockette_12();
int print_blockette_30();
int print_blockette_31();
int print_blockette_32();
int print_blockette_33();
int print_blockette_34();
int print_blockette_35();
int print_blockette_41();
int print_blockette_42();
int print_blockette_43();
int print_blockette_44();
int print_blockette_45();
int print_blockette_46();
int print_blockette_47();
int print_blockette_48();
int print_blockette_50();
int print_blockette_51();
int print_blockette_52();
int print_blockette_53();
int print_blockette_54();
int print_blockette_55();
int print_blockette_56();
int print_blockette_57();
int print_blockette_58();
int print_blockette_59();
int print_blockette_60();
int print_blockette_61();
int print_blockette_62();
int print_blockette_70();
int print_blockette_71();
int print_blockette_72();
int print_blockette_73();
int print_blockette_74();



/* the functions below are used when checking blockettes for errors.
   Because each blockette is more or less similar, we can use these
   functions to check for errors */

void check_length(/*address_of_field, field_number, field_name, field_length, blockette_length,
		  min_blockette_length, max_blockette_length, address_of_result*/);

int check_number_mask(/*point_to_field, field_num, field_name, field_length, decimal_position, 
			exponential_position, signed, &result_struct*/);
int check_number_between_two_values(/*point_to_field, filed_num, field_name, field_length, 
				      smallest, largest, &result*/);
void check_number_less_than_value(/*field, field_number, field_name, field_length, max_value, result*/);
void check_number_greater_than_value(/*field, field_number, field_name, field_length, min_value, result*/);
int check_number_equal_to_value(/*field, field_number, field_name, field_length, equal_value, print_error, result*/);
void check_number_one_of_two_values(/*field, field_number, field_name, field_length, value1, value2, result*/);
int return_number(/*field, field_length*/);

int check_time_mask(/*point_to_field, field_num, field_name, max_length, &result*/);

/*  This function makes sure that time1 occurs earlier than time2.
    It also assumes that check_time_mask has been called for both time1 and time2 */
void check_two_times(/*time1_field, time1_field_number, time1_name, time1_length, 
		       time2_field, time2_field_number, time2_name, time2_length, result*/);

int check_string_mask(/*point_to_field, field_num, field_name, max_length, variable_length, limitations, &result*/);
int check_char_value(/*field, field_number, field_name, field_length, value, print_error, result*/);
void check_char_one_of_two_values(/*field, field_number, field_name, field_length, value1, value2, result*/);

void add_error_to_result(/*field, field_number, field_name, field_length, error, error_string, result*/);


int get_variable_field(/*blockette, field, max_length*/);


void print_errors(/*result*/);
void print_blockette_length_problem(/*bytes_read, num_bytes_to_read, result*/);

