#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>








int read_full_record(FILE *fptr, char *buf, int len) 

{
	int n_bytes, bytes_so_far = 0;
	int fd;

	fd = fileno(fptr);

	memset(buf, ' ', len);

	do
	{
		n_bytes = read(fd, buf + bytes_so_far, len - bytes_so_far);
		bytes_so_far += n_bytes;

	} while ((n_bytes > 0) && (bytes_so_far < len));


	if(n_bytes < 0) 
	{
		fprintf(stderr, "ERROR - unable to continue due to a I/O error\n");
		perror("read_full_record");
		exit(0);
	}

	/* if 0 bytes read and a tape device, make second read
	 * to move past eof mark
	 */

	if (n_bytes == 0 && tape_device(fd))
	{
		memset(buf, ' ', len);
		bytes_so_far = 0;

	        do
        	{ 
                	n_bytes = read(fd, buf + bytes_so_far, 
						len - bytes_so_far);
 
                	bytes_so_far += n_bytes; 
 
        	} while ((n_bytes > 0) && (bytes_so_far < len));
 
		if(n_bytes < 0) {
			fprintf(stderr, "ERROR - unable to continue due to a I/O error\n");
			perror("read_full_record");
			exit(0);
		}
	}
			
	return bytes_so_far;

}

int tape_device(int fdesc)

{

	struct stat buf;

	fstat(fdesc, &buf);

	return buf.st_mode & S_IFBLK;

}

