/*===========================================================================*/
/* SEED reader     |                timeprt                |         utility */
/*===========================================================================*/
/*
	Name:		timeprt
	Purpose:	printf of int struct time format
	Usage:		int timecmp ();
				struct time time1;
	Input:		time1 = 1st time in struct time format (see Notes)
	Output:		time output
	Externals:	none
	Warnings:	none
	Errors:		none
	Called by:	anything
	Calls to:	none
	Algorithm:
	Notes:		The time structure looks like:
					struct time
					{
						int year;
						int day;
						int hour;
						int minute;
						int second;
						int fracsec;
					};
	Problems:	none known
	References:	none
	Language:	C, hopefully ANSI standard
	Author:		Dennis O'Neill
	Revisions:	Date      Revised by      Comment
*/

#include "rdseed.h"
#define TOLERANCE 1								/* tolerance in .0001 secs */

int timeprt (time)
struct time time;
{
	/* print year */
	fprintf (stderr,"%4d,",time.year);

	/* print day */
	fprintf (stderr,"%3d,",time.day);

	/* print hour */
	fprintf (stderr,"%2d:",time.hour);

	/* print minute */
	fprintf (stderr,"%02d:",time.minute);

	/* print second */
	fprintf (stderr,"%02d.",time.second);

	/* print fractional second */
	fprintf (stderr,"%04d",time.fracsec);

}

char *strtime(buffer, time)
char *buffer;
struct time *time;

{
	sprintf(buffer, "%4d,%3d,%2d:%02d:%02d.%04d",
					 time->year,
					 time->day,
					 time->hour,
					 time->minute,
					 time->second,
					 time->fracsec);

	return buffer;
}

